<?php
// $Id: render.php,v 1.2 2005/10/13 12:48:32 driesk Exp $
    header("Content-type: image/png");
    $stats = $_GET;
    $graph = imagecreatetruecolor(426, 235);
    
    // change the rgb values to set the background color
    $bgcolor = imagecolorallocate($graph, 255, 255, 255);
    // change the rgb values to set the fill and line color
    $fillcolor = imagecolorallocate($graph, 0, 119, 192);
    // change the rgb values to set the text color
    $txtcolor = imagecolorallocate($graph, 0, 0, 0);
    // change the rgb values to set the horizontal grid color
    $gridcolor = imagecolorallocate($graph, 156, 156, 156);
    
    // create the basics: background, axes, gridlines
    imagefill($graph, 0, 0, $bgcolor);
    imagedrawpointgrid($graph, 10, 10, array( "R" => 0x00, "G" => 0x00, "B" => 0x00, "A" => 0xB0 ), 65, -31);
    imageline($graph, 65, 0, 65, 199, $fillcolor);
    imageline($graph, 65, 199, 425, 199, $fillcolor);
    imageline($graph, 66, 149, 425, 149, $gridcolor);
    imageline($graph, 66, 99, 425, 99, $gridcolor);
    imageline($graph, 66, 49, 425, 49, $gridcolor);
    imageline($graph, 66, 0, 425, 0, $gridcolor);
    
    // set legends on axes
    if ($stats['x']) {
      imagestring($graph, 3, 215, 215, $stats['x'], $txtcolor);
    }
    if ($stats['y']) {
      imagestringup($graph, 3, 0, 150, $stats['y'], $txtcolor);
    }
    
    // create histograms
    if ($stats['h']) {
      $h = explode(',', $stats['h']);
      $s = $stats['s'] ? explode(',', $stats['s']) : FALSE;
      if ($s) {
        foreach ($h as $key => $value) {
          $max[] = $value + $s[$key];
        }
      }
      else {
        $max = $h;
      }
      $y_scale = y_scale(max($max));
      imagestring($graph, 2, 17, 149, $y_scale * 0.25, $txtcolor);
      imagestring($graph, 2, 17, 99, $y_scale * 0.5, $txtcolor);
      imagestring($graph, 2, 17, 49, $y_scale * 0.75, $txtcolor);
      imagestring($graph, 2, 17, 0, $y_scale, $txtcolor);
      $x_offset_bar = 70;
      $y_offset_bar = 90;
      $x_offset_flag = 80;
      $t1 = '0';
      $t2 = '2';
      foreach ($h as $key => $value) {
        $start_flag = $x_offset_flag - 5;
        $stop_flag = $x_offset_flag + 5;
        $marker = $y_offset_bar + 5;
        $height = 199 - ($value / $y_scale * 200);
        imagefilledrectangle($graph, $x_offset_bar, $height, $y_offset_bar, 199, $fillcolor);
        if ($s) {
          $se = $height - ($s[$key] / $y_scale * 200);
          imageline($graph, $x_offset_flag, $height, $x_offset_flag, $se, $fillcolor);
          imageline($graph, $start_flag, $se, $stop_flag, $se, $fillcolor);
        }
        imageline($graph, $marker, 204, $marker, 194, $fillcolor);
        imagestring($graph, 1, $x_offset_bar, 202, $t1.'-'.$t2, $txtcolor);
        $t1 = $t1 + 2;
        $t2 = $t2 + 2;
        $x_offset_bar = $x_offset_bar + 30;
        $y_offset_bar = $y_offset_bar + 30;
        $x_offset_flag = $x_offset_flag + 30;
      }
    }
    
    // create line graphs
    elseif ($stats['l']) {
      $l = explode(',', $stats['l']);
      $xl = $stats['xl'] ? explode(',', $stats['xl']) : FALSE;
      $y_scale = y_scale(max($l));
      imagestring($graph, 2, 17, 149, $y_scale * 0.25, $txtcolor);
      imagestring($graph, 2, 17, 99, $y_scale * 0.5, $txtcolor);
      imagestring($graph, 2, 17, 49, $y_scale * 0.75, $txtcolor);
      imagestring($graph, 2, 17, 0, $y_scale, $txtcolor);
      $x_offset_bar = 70;
      $y_offset_bar = 90;
      $x_offset_flag = 80;
      $odd = 1;
      foreach ($l as $key => $value) {
        imageantialias($graph, TRUE);
        if ($odd % 2) {
          $from = 199 - ($value / $y_scale * 200);
          if ($odd != 1) {
            imageline($graph, $x_offset_flag -30, $to, $x_offset_flag, $from, $fillcolor);
          }
        }
        else {
          $to = 199 - ($value / $y_scale * 200);
          imageline($graph, $x_offset_flag - 30, $from, $x_offset_flag, $to, $fillcolor);
        }
        imageantialias($graph, FALSE);
        $marker = $y_offset_bar + 5;
        imageline($graph, $marker, 204, $marker, 194, $fillcolor);
        $x_offset_bar = $x_offset_bar + 30;
        $y_offset_bar = $y_offset_bar + 30;
        $x_offset_flag = $x_offset_flag + 30;
        $odd++;
      }
      if ($xl) {
        $offset = 70;
        foreach ($xl as $x) {
          imagestring($graph, 1, $offset, 208, $x, $txtcolor);
          $offset = $offset + 101;
        }
      }
    }
    imagepng($graph);
    imagedestroy($graph);

/**
 * Determine maximum y-axis value
 */
function y_scale($max) {
  $y_scale = 1;
  $odd = 1;
  while ($y_scale <= ($max + (0.1 * $max))) {
    if ($odd % 2) {
      $y_scale = $y_scale * 5;
    }
    else {
      $y_scale = $y_scale * 2;
    }
    $odd++;
  }
  return $y_scale;
}

/**
 * Draw point grid
 * source: http://www.kosmokrator.com/download/php/
 */
function imagedrawpointgrid(&$srcImage, $intXSize = 8, $intYSize = 8, $rgbPoint = array( "R" => 0x00, "G" => 0x00, "B" => 0x00, "A" => 0xD0 ), $intXOffset = 0, $intYOffset = 0) {
  $intWidth = imageSX($srcImage) / $intXSize;
  $intHeight= imageSY($srcImage) / $intYSize;
  $colDraw= imageColorExactAlpha($srcImage, $rgbPoint[ "R" ], $rgbPoint[ "G" ], $rgbPoint[ "B" ], $rgbPoint[ "A" ] );
  for ( $y = 0; $y < $intHeight; $y++ ) {
    for ( $x = 0; $x < $intWidth; $x++ ) {
      imageSetPixel($srcImage, $x * $intXSize + $intXOffset, $y * $intYSize + $intYOffset, $colDraw);
    }
  }
}

?>
